package GMB::Plugin::FetchCover;
use strict;
use warnings;
require 'simple_http.pm';
use base 'Gtk2::Window';
use constant
{	PID => 'FETCHCOVER',#used to identify the plugin and its options
	RES_LINES => 4,
	RES_PER_LINE => 5,
	PREVIEW_SIZE => 100,
};
use constant RES_PER_PAGE => RES_PER_LINE*RES_LINES;

my %menuentry=
(	label => _"Look for a picture in google images",#label of the menu entry
	code => sub {Fetch($_[0]{ID},'album')},		#when menu entry selected
	test => sub {$_[0]{col}==::SONG_ALBUM},		#the menu entry is displayed if returns true
);
my %menuentry2=
(	label => _"Look for a picture in google images",
	code => sub {Fetch($_[0]{ID},'artist',$_[0]{key})},
	test => sub {$_[0]{col}==::SONG_ARTIST},
);
my %fpaneentry=
(	label=> _"Look for a picture in google images",
	code => sub { my $aa=$_[0]{aa}; my $key=$_[0]{keylist}[0]; my $ID=($aa eq 'artist' ? \%::Artist : \%::Album)->{$key}[::AALIST][0]; $key=undef if $aa eq 'album'; Fetch($ID,$aa,$key) if defined $ID; },
	onlyone=> 'keylist',
	istrue => 'aa',
);

::SetDefaultOptions(PID, USEFILE => 1, COVERFILE => 'cover');

$::Plugins{&PID}=__PACKAGE__;

sub init
{	push @::cMenuAA,\%menuentry,\%menuentry2;
	push @FilterPane::cMenu, \%fpaneentry;
}
sub end
{	@::cMenuAA=  grep $_!=\%menuentry && $_!=\%menuentry2, @::SongCMenu;
	@FilterPane::cMenu= grep $_!=\%fpaneentry, @FilterPane::cMenu;
}
sub name { _"Fetch cover" }

sub prefbox
{	my $label1=Gtk2::Label->new(_"FetchCover plugin");
	my $label2=Gtk2::Label->new(_"Adds a menu entry to album context menu, allowing to search the cover in google and save it.");
	$label2->set_line_wrap(::TRUE);
	my $check1=::NewPrefCheckButton('PLUGIN_'.PID.'_ASK',_"Ask confirmation only if file already exists");
	my $check2=::NewPrefCheckButton('PLUGIN_'.PID.'_UNIQUE',_"Find a unique filename if file already exists");
	my $entry1=::NewPrefEntry('PLUGIN_'.PID.'_COVERPATH','');
	my $entry2=::NewPrefEntry('PLUGIN_'.PID.'_COVERFILE','');
	my ($radio1a,$radio1b)=::NewPrefRadio('PLUGIN_'.PID.'_USEPATH',undef,_"use song folder",0,_"use :",1);
	my ($radio2a,$radio2b)=::NewPrefRadio('PLUGIN_'.PID.'_USEFILE',undef,_"use album name",0,_"use :",1);
	my $frame1=Gtk2::Frame->new(_"default folder");
	my $frame2=Gtk2::Frame->new(_"default filename");
	my $vbox1=::Vpack( $radio1a,[$radio1b,$entry1] );
	my $vbox2=::Vpack( $radio2a,[$radio2b,$entry2] );
	$frame1->add($vbox1);
	$frame2->add($vbox2);
	return ::Vpack( $label1,$label2,$frame1,$frame2,$check1,$check2 );
}

sub Fetch
{	my ($ID,$aa,$artist)=@_;
	my $self=bless Gtk2::Window->new;
	$self->set_border_width(4);
	$self->set_default_size(RES_LINES*PREVIEW_SIZE,RES_PER_LINE*PREVIEW_SIZE); #FIXME should save size
	my $Bsearch=::NewIconButton('gtk-find',_"Search");
	my $BcurAlb=Gtk2::Button->new(_"Search for current album");
	my $Bclose=Gtk2::Button->new_from_stock('gtk-close');
	$self->{searchentry}=	my $entry=Gtk2::Entry->new;
	#$self->{Bnext}=	my $Bnext=::NewIconButton('gtk-go-forward',"More");
	$self->{Bnext}=		my $Bnext=Gtk2::Button->new(_"More results");
	$self->{Bstop}=		my $Bstop=Gtk2::Button->new_from_stock('gtk-stop');
	$self->{progress}=	my $pbar =Gtk2::ProgressBar->new;
	$self->{table}=		my $table=Gtk2::Table->new(RES_LINES,RES_PER_LINE,::TRUE);
	$self->add( ::Vpack
			(	['_',$entry, $Bsearch, $Bstop],
				'_',$table,
				'-', ['_',$pbar , '-', $Bclose,$Bnext,$BcurAlb]
			) );
	$self->show_all;

	$entry->signal_connect(  activate => \&NewSearch );
	$Bsearch->signal_connect( clicked => \&NewSearch );
	$Bstop->signal_connect( clicked => sub {$_[0]->get_toplevel->stop });
	$Bclose->signal_connect(clicked => sub {$_[0]->get_toplevel->destroy});
	$Bnext->signal_connect( clicked => sub {$_[0]->get_toplevel->NextPage});
	$BcurAlb->signal_connect(clicked =>sub {$_[0]->get_toplevel->SearchID($::SongID,'album')});
	$self->signal_connect( destroy => \&abort);

	$self->SearchID($ID,$aa,$artist);
}

sub SearchID
{	my ($self,$ID,$aa,$artist)=@_;
	$self=::find_ancestor($_[0],__PACKAGE__);


	$artist=$::Songs[$ID][::SONG_ARTIST] unless defined $artist;
	$artist='' if $artist eq '<Unknown>';
	$self->{dir}=$::Songs[$ID][::SONG_PATH];
	my $search;
	if ($aa && $aa eq 'artist')
	{	$self->{artist}=$artist;
		delete $self->{album};
		$search="\"$artist\"" unless $artist eq '';
	}
	else
	{	my $album=$::Songs[$ID][::SONG_ALBUM];
		$album='' if $album=~m/^<Unknown>/;
		$self->{album}=$album;
		delete $self->{artist};
		$search= $album=~m/^<Unknown>/ ? '' : "\"$album\"";
		$search.=" \"$artist\"" unless $search eq '' || $artist eq '';
	}
	$self->{searchentry}->set_text($search);
	$self->NewSearch;
}

sub NewSearch
{	my $self=::find_ancestor($_[0],__PACKAGE__);
#$self->{page}=0;
	$self->{results}=[];
	my $search=$self->{searchentry}->get_text;
	return if $search eq '';
	$self->{page}=0;
	$self->InitPage(0);
	$search=::url_escapeall($search);
	$self->{waiting}=Simple_http::get_with_cb
	 (	cb => sub {$self->searchresults_cb(@_)},
		url => 'http://images.google.com/images?q='.$search.'&imgsz=medium|large',
		cache=>1
	 );
}

sub InitPage
{	my $self=$_[0];
	$self->abort;
	$self->{loaded}=0;
	$self->{Bnext}->set_sensitive(1);
	$self->{Bstop}->set_sensitive(1);
	$self->{progress}->set_fraction(0);
	$self->{progress}->show;
	my $table=$self->{table};
	$table->remove($_) for $table->get_children;
}

sub PrevPage
{	my $self=$_[0];
	return unless $self->{page};
	$self->{page}--;
	$self->InitPage;
	::IdleDo('8_FetchCovers'.$self,100,\&get_next,$self);
}

sub NextPage
{	my $self=$_[0];
	$self->{page}++;
	$self->InitPage;
	::IdleDo('8_FetchCovers'.$self,100,\&get_next,$self);
}

sub searchresults_cb
{	my ($self,$result)=@_;
	$self->{waiting}=undef;
	unless (defined $result) { stop($self,_"connection failed."); return; }
	my @list;
	while ($result=~m#dyn.Img\(("[^"]*"(?:,"[^"]*")*)\);#g) #parse google image results
	{	my @fields= $1=~m#"([^"]*)",?#g;
		my $url=$fields[3];
		my $desc=$fields[6]; $desc=~s#\\x([0-9a-z]{2})#chr(hex $1)#gie; $desc=~s#</?b>##g;
		$desc=Encode::decode('cp1252',$desc); #FIXME not sure of the encoding
		$desc=::decode_html($desc); #FIXME not all html entities are supported : &middot;
		my $preview='http://images.google.com/images?q=tbn:'.$fields[2].$url;
		push @list, {url => $url, previewurl =>$preview, desc => $desc };
	}
	if ($result=~m#Result[^<]*Page:.*<a href=(/images\?q=[^>]+).*?>Next</a></table>#) #could be better
	{	$self->{nexturl}='http://images.google.com'.$1; #warn $1;
	}
	else
	{	$self->{Bnext}->set_sensitive(0);
	}
	#warn scalar @list;
	#while ($result=~m#<img src=([^>]*?) width=\d+ height=\d+>(?:.*?imgurl=([^>]*?)&)?#g) #old google image
	#{	my $url='http://images.google.com'.$1;
	#	$url= $2? [$2,$url] : $url;
	#	push @list, $url;
	#}
	unless (@list) { stop($self,_"no matches found, you might want to remove some search terms."); return; }
	$self->{total}+=@list;
	#$table->set_size_request(110*5,110*int(1+@list/5));
	push @{$self->{results}}, @list;
	::IdleDo('8_FetchCovers'.$self,100,\&get_next,$self);
}

sub abort
{	my $self=$_[0];
	my $results=$self->{results};
	for my $r ($self,@$results)
	{	delete $r->{done};
		$r->{waiting}->abort if $r->{waiting};
		delete $r->{waiting};
	}
	delete $self->{waiting};
	delete $::ToDo{'8_FetchCovers'.$self};
}

sub stop
{	my ($self,$error)=@_;
	$self->abort;
	$self->{Bstop}->set_sensitive(0);
	#$self->{progress}->set_fraction(1);
	$self->{progress}->hide;
	if ($error)
	{	my $l=Gtk2::Label->new($error);
		$l->show;
		$self->{table}->attach($l,0,5,0,1,'fill','fill',1,1);
	}
}

sub get_next
{	my $self=shift;
	my $results=$self->{results};
	my $res_id;
	my $waiting;
	my $start= $self->{page} * RES_PER_PAGE;
	my $end= $start + RES_PER_PAGE -1;
	if ($#$results<$end && $self->{nexturl})
	{	#load next page
		$self->{waiting}=Simple_http::get_with_cb(cb => sub {$self->searchresults_cb(@_)}, url => delete $self->{nexturl}, cache=>1);
	}
	$end=$#$results if $#$results<$end;
	for my $id ($start .. $end)
	{	#warn "$id : waiting=".$results->[$id]{waiting}." done=".$results->[$id]{done};
		if ($results->[$id]{waiting}) {$waiting++; next};
		next if $results->[$id]{done};
		$res_id=$id;
		last;
	}
	unless (defined $res_id || $waiting || $self->{waiting})
	{	$self->stop;
		return;
	}
	return unless defined $res_id;
	return if $waiting && $waiting > 1; #no more than 2 pictures at once

	my $result=$self->{results}[$res_id];
	$result->{waiting}=Simple_http::get_with_cb(url => $result->{url}, cache=>1, cb =>
	sub
	{	my $pixdata=$_[0];
		$result->{waiting}=undef;
		my $loader;
		$loader=::LoadPixData($pixdata,PREVIEW_SIZE) if $pixdata;
		if ($loader)
		{	my $dim=$loader->{w}.' x '.$loader->{h};
			my $table=$self->{table};
			my $pixbuf=$loader->get_pixbuf;
			my $image=Gtk2::Image->new_from_pixbuf($pixbuf);
			my $button=Gtk2::Button->new;
			$button->{pixdata}=$pixdata;
			$button->{ext}=	($Gtk2::VERSION >= 1.092)?
					  $loader->get_format->{extensions}[0]
					: ( EntryCover::_identify_pictype($pixdata) )[0];
			$button->add($image);

			my $tip='';
			$tip=$result->{desc}."\n" if $result->{desc};
			$tip.=$dim."\n".$result->{url};
			$::Tooltips->set_tip($button,$tip);
			$button->signal_connect(clicked => \&set_cover);
			$button->signal_connect(button_press_event => \&::pixbox_button_press_cb,3); # 3 : mouse button 3
			$button->set_relief('none');
			$button->show_all;
			my $i= $res_id % RES_PER_PAGE;
			my $y=int( $i/RES_PER_LINE);
			my $x= $i % RES_PER_LINE;
			$table->attach($button,$x,$x+1,$y,$y+1,'fill','fill',1,1);
			$result->{done}=1;
			$self->{loaded}++;
		}
		elsif ($result->{previewurl})
		{	$result->{originurl}=$result->{url};
			$result->{url}=delete $result->{previewurl};
		}
		else { $result->{done}='error'; $self->{loaded}++; }
		$self->{progress}->set_fraction( $self->{loaded} / ( @{$self->{results}} - RES_PER_PAGE*$self->{page} ));
		::IdleDo('8_FetchCovers'.$self,100,\&get_next,$self);
	});
	::IdleDo('8_FetchCovers'.$self,1000,\&get_next,$self);
}

sub set_cover
{	my $button=$_[0];
	my $self=::find_ancestor($button,__PACKAGE__);
	my ($aa,$text,$href);
	if (defined $self->{album})
	{	$aa=$self->{album};
		$text=::__x(_"Use this picture as cover for album '{album}'", album => $aa);
		$href=$::Album{$aa};
	}
	else
	{	$aa=$self->{artist};
		$text=::__x(_"Use this picture for artist '{artist}'", artist => $aa);
		$href=$::Artist{$aa};
	}
	my $check=Gtk2::CheckButton->new( $text );
	$check->set_active(1);
	my $default_file=	$::Options{'PLUGIN_'.PID.'_USEFILE'} ?
			$::Options{'PLUGIN_'.PID.'_COVERFILE'} : $aa;
	$default_file=~s/\.(?:jpg|png|gif)$//;
	$default_file.='.'.$button->{ext};
	$default_file=~s/$::ILLEGALCHAR//g;
	$default_file=::filename_from_unicode($default_file);
	my $default_dir=$::Options{'PLUGIN_'.PID.'_COVERPATH'} || '';
	$default_dir=::filename_from_unicode($default_dir);
	$default_dir=~s/$::ILLEGALCHARDIR//g;
	$default_dir=$self->{dir} unless $::Options{'PLUGIN_'.PID.'_USEPATH'} && -d $default_dir;
	if ($::Options{'PLUGIN_'.PID.'_UNIQUE'})
	{	while (-e $default_dir.::SLASH.$default_file) #find a unique name
		{ last unless $default_file=~s/(?:_(\d+))?\.(\w+)$/'_'.($1? $1+1 : 1).".$2"/e ; }
	}
	my $file=$default_dir.::SLASH.$default_file;
	if (!$::Options{'PLUGIN_'.PID.'_ASK'} || -e $file)
	{$file=::ChooseSaveFile($self,_"Save picture as",
		$default_dir,$default_file,
		$check);
	}
	return unless $file;
	my $fh;
	until (open $fh,'>',$file)
	{	my $retry=::Retry_Dialog( ::__x( _"Error writing '{file}'", file => ::filename_to_utf8displayname($file) )." :\n$!." ,$self);
		return unless $retry eq 'yes';
	}
	print $fh $button->{pixdata};
	close $fh;
	return unless $check->get_active;
	$href->[::AAPIXLIST]=$file;
	::HasChanged('AAPicture',$aa);
}

1

__END__
xml.amazon.com/onca/xml3?t=webservices-20&dev-t=%l&KeywordSearch=%s&mode=music&type=heavy&locale=us&page=1&f=xml
