package GMB::Plugin::gnome_mmkeys;
use strict;
use warnings;
use constant
{	PID => 'GMMKEYS',
	name => _"Gnome mmkeys",
};

use Net::DBus;

my $bus= Net::DBus->find;
my $service = $bus->get_service('org.gnome.SettingsDaemon');
my $object = $service->get_object('/org/gnome/SettingsDaemon');
$object->connect_to_signal(MediaPlayerKeyPressed => \&callback);

$::Plugins{&PID}=__PACKAGE__;

my %cmd=
(	Previous	=> 'PrevSong',
	Next		=> 'NextSong',
	Play		=> 'PlayPause',
	Stop		=> 'Stop',
);

sub init
{	$object->GrabMediaPlayerKeys('gmusicbrowser',0);
}
sub end
{	$object->ReleaseMediaPlayerKeys('gmusicbrowser');
}
sub prefbox
{	my $vbox=Gtk2::VBox->new(::FALSE, 2);
	my $label1=Gtk2::Label->new(_"Gnome multimedia keys plugin");
	my $label2=Gtk2::Label->new(_"Makes gmusicbrowser reacts to the Next/Previous/Play/Stop multimedia keys in gnome.");
	$label2->set_line_wrap(1);
	$vbox->pack_start($_,::FALSE,::FALSE,2) for $label1,$label2;
	return $vbox;
}

sub callback
{	my ($app,$key)=@_;
	return unless $app eq 'gmusicbrowser';
	if (my $cmd=$cmd{$key}) { ::run_command(undef,$cmd); }
	else { warn "gnome_mmkeys : unknown key : $key\n" }
}

1
