package GMB::Plugin::Rip;
use strict;
use warnings;
use constant
{	PID => 'RIP',#used to identify the plugin and its options
	name => _"Rip",
};

$::Plugins{&PID}=__PACKAGE__;
::SetDefaultOptions(PID, program => 'soundjuicer');

my %Programs= #id => [name,cmd]
(	soundjuicer => ['sound-juicer','sound-juicer'],
	grip => ['grip','grip'],
	xcfa => ['xcfa','xcfa'],
	custom => [_"custom"],
);

sub init
{	ExtraWidgets::AddWidget(PID.'_button','button',\&CreateButton);
}
sub end
{	ExtraWidgets::RemoveWidget(PID.'_button');
}

sub prefbox
{	my $vbox=Gtk2::VBox->new(::FALSE, 2);
	my $label1=Gtk2::Label->new(_"Rip plugin");
	my $label2=Gtk2::Label->new(_"Add a button to rip a CD");
	my $sg1=Gtk2::SizeGroup->new('horizontal');
	my $sg2=Gtk2::SizeGroup->new('horizontal');
	my $entry=::NewPrefEntry('PLUGIN_'.PID.'_custom', _"Custom command :",undef,$sg1,$sg2,undef,_('Command to launch when the button is pressed'));
	my %list= map {$_,$Programs{$_}[0]} keys %Programs;
	my $combo= ::NewPrefCombo
	 (	'PLUGIN_'.PID.'_program', \%list,
		_"Ripping software :",
		sub { $entry->set_sensitive( $::Options{'PLUGIN_'.PID.'_program'} eq 'custom' ) },
		$sg1,$sg2
	 );
	$entry->set_sensitive( $::Options{'PLUGIN_'.PID.'_program'} eq 'custom' );
	$vbox->pack_start($_,::FALSE,::FALSE,2) for $label1,$label2,$combo,$entry;
	return $vbox;
}

sub CreateButton
{	my $button=Gtk2::Button->new_from_stock('plugin-rip');
	$button->signal_connect(clicked => \&Launch);
	return $button;
}

sub Launch
{	my $program=$::Options{'PLUGIN_'.PID.'_program'};
	my $cmd=$program eq 'custom' ?
		 $::Options{'PLUGIN_'.PID.'_custom'} :
		 $Programs{$program}[1];
	::forksystem($cmd) if $cmd;
}

1;
